VERSION 5.00
Object = "{86CF1D34-0C5F-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCT2.OCX"
Begin VB.Form frmOP2Graphics 
   Caption         =   "Outpost 2 Graphics"
   ClientHeight    =   5115
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7365
   LinkTopic       =   "Form1"
   ScaleHeight     =   5115
   ScaleWidth      =   7365
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame fmeSprites 
      Caption         =   "Sprites"
      Height          =   3735
      Left            =   0
      TabIndex        =   1
      Top             =   1320
      Width           =   7335
      Begin VB.PictureBox picSprite 
         Height          =   3015
         Left            =   120
         ScaleHeight     =   197
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   469
         TabIndex        =   9
         Top             =   600
         Width           =   7095
      End
      Begin MSComCtl2.UpDown udSpriteIndex 
         Height          =   285
         Left            =   3360
         TabIndex        =   8
         Top             =   240
         Width           =   255
         _ExtentX        =   450
         _ExtentY        =   503
         _Version        =   393216
         AutoBuddy       =   -1  'True
         BuddyControl    =   "txtSpriteIndex"
         BuddyDispid     =   196616
         OrigLeft        =   3360
         OrigTop         =   240
         OrigRight       =   3615
         OrigBottom      =   495
         Max             =   0
         SyncBuddy       =   -1  'True
         BuddyProperty   =   65547
         Enabled         =   -1  'True
      End
      Begin VB.TextBox txtSpriteIndex 
         BeginProperty DataFormat 
            Type            =   0
            Format          =   "0"
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   1033
            SubFormatType   =   0
         EndProperty
         Height          =   285
         Left            =   2400
         TabIndex        =   7
         Text            =   "0"
         Top             =   240
         Width           =   960
      End
      Begin VB.Label lblTitle 
         Caption         =   "OP2_ART (.BMP / .PRT)"
         Height          =   195
         Left            =   120
         TabIndex        =   10
         Top             =   240
         Width           =   2160
      End
      Begin VB.Label lblNumLoadedSprites 
         Caption         =   "Loaded Images: 0"
         Height          =   195
         Left            =   3720
         TabIndex        =   6
         Top             =   240
         Width           =   3480
      End
   End
   Begin VB.Frame fmeTileSets 
      Caption         =   "Tile Sets"
      Height          =   1260
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   7335
      Begin VB.PictureBox picTileSet 
         Height          =   540
         Left            =   120
         ScaleHeight     =   32
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   469
         TabIndex        =   5
         Top             =   600
         Width           =   7095
      End
      Begin MSComCtl2.UpDown udTileSetIndex 
         Height          =   285
         Left            =   3361
         TabIndex        =   4
         Top             =   240
         Width           =   255
         _ExtentX        =   450
         _ExtentY        =   503
         _Version        =   393216
         AutoBuddy       =   -1  'True
         BuddyControl    =   "txtTileSetIndex"
         BuddyDispid     =   196612
         OrigLeft        =   3600
         OrigTop         =   240
         OrigRight       =   3855
         OrigBottom      =   495
         Max             =   0
         SyncBuddy       =   -1  'True
         BuddyProperty   =   65547
         Enabled         =   -1  'True
      End
      Begin VB.TextBox txtTileSetIndex 
         BeginProperty DataFormat 
            Type            =   0
            Format          =   "0"
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   1033
            SubFormatType   =   0
         EndProperty
         Height          =   285
         Left            =   2400
         TabIndex        =   3
         Text            =   "0"
         Top             =   240
         Width           =   960
      End
      Begin VB.ComboBox cmbTileSets 
         Height          =   315
         ItemData        =   "frmOP2Graphics.frx":0000
         Left            =   120
         List            =   "frmOP2Graphics.frx":002B
         Style           =   2  'Dropdown List
         TabIndex        =   2
         Top             =   240
         Width           =   2175
      End
      Begin VB.Label lblNumLoadedTiles 
         Caption         =   "Loaded Tiles: 0"
         Height          =   195
         Left            =   3720
         TabIndex        =   11
         Top             =   240
         Width           =   3480
      End
   End
End
Attribute VB_Name = "frmOP2Graphics"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' ************************************
' Outpost 2 Graphics viewer by Hooman.
'
' Note: the current directory will be
' check first for the required files,
' (followed by possible sub folders
' of the current directory), followed
' by the hardcoded default directory
' below.
'
' Note: Graphics must be extracted
' from the VOL files for this program
' to load them.
' ************************************

Option Explicit

Private Const DefaultPath As String = "\Sierra\outpost2\"


Private prtFile As New CPrtFile
Private wellFile(12) As New CTileSetFile


Private Sub Form_Load()
    Dim i As Long
    Dim fileName As String

    ' Try to open the Sprite resource files
    ' *************************************
    
    If prtFile.OpenBitmapFile("op2_art.bmp") <> 0 Then
        If prtFile.OpenBitmapFile(DefaultPath + "op2_art.bmp") <> 0 Then
            ' Error loading bitmap data
            MsgBox "Error loading OP2_ART.BMP"
            Unload Me
            End
        End If
    End If
    If prtFile.OpenPrtFile("op2_art.prt") <> 0 Then
        If prtFile.OpenPrtFile("Maps\op2_art.prt") <> 0 Then
            If prtFile.OpenPrtFile(DefaultPath + "Maps\op2_art.prt") <> 0 Then
                ' Error loading PRT data
                MsgBox "Error loading PRT data"
                Unload Me
                End
            End If
        End If
    End If

    ' Update the number of loaded sprites
    lblNumLoadedSprites.Caption = "Loaded Images: " + Format$(prtFile.numImages)
    udSpriteIndex.Max = prtFile.numImages - 1


    ' Try to load the Tile Set resource files
    ' ***************************************
    'Dim numTilesLoaded As Long

    ' Load the tile sets
    For i = 0 To 12
        fileName = "well00" + Format$(i, "0#") + ".bmp"
        If wellFile(i).OpenFile(fileName) <> 0 Then
            If wellFile(i).OpenFile("Maps\" + fileName) <> 0 Then
                If wellFile(i).OpenFile(DefaultPath + "Maps\" + fileName) <> 0 Then
                    'MsgBox "Error loading Tile Set data"
                End If
            End If
        End If
        'numTilesLoaded = numTilesLoaded + wellFile(i).numTiles
    Next i
    
    'Debug.Print numTilesLoaded

    cmbTileSets.ListIndex = 0
End Sub


Private Sub Form_Resize()
    ' Make sure the window isn't minimized
    If Me.ScaleHeight > 0 Then
        ' Update size of frames
        fmeTileSets.Width = Me.ScaleWidth - fmeTileSets.Left
        fmeSprites.Move fmeSprites.Left, fmeSprites.Top, Me.ScaleWidth - fmeSprites.Left, Me.ScaleHeight - fmeSprites.Top
        
        ' Update size of controls in the TileSet frame
        picTileSet.Width = fmeTileSets.Width - picTileSet.Left * 2
        
        ' Update size of controls in the Sprite frame
        picSprite.Move picSprite.Left, picSprite.Top, fmeSprites.Width - picSprite.Left * 2, fmeSprites.Height - picSprite.Top - picSprite.Left
    End If
End Sub



Private Sub txtTileSetIndex_Change()
    ' Update the displayed tile
    If Val(txtTileSetIndex.Text) <= udTileSetIndex.Max Then
        udTileSetIndex.Value = Val(txtTileSetIndex.Text)
    End If
    ' Update displayed value
    txtTileSetIndex.Text = Format$(udTileSetIndex.Value)
End Sub

Private Sub cmbTileSets_Click()
    ' Update the number of tiles in the current tile set
    lblNumLoadedTiles.Caption = "Loaded Tiles: " + Format$(wellFile(cmbTileSets.ListIndex).numTiles)
    udTileSetIndex.Max = wellFile(cmbTileSets.ListIndex).numTiles - 1
    
    ' Update the view
    picTileSet_Paint
End Sub

Private Sub udTileSetIndex_Change()
    picTileSet_Paint
End Sub

Private Sub picTileSet_Paint()
    Dim i As Long
    Dim start As Long
    Dim numTiles As Long

    ' Determine which tiles to draw
    start = udTileSetIndex.Value
    numTiles = picTileSet.ScaleWidth \ 33
    start = start - numTiles \ 2
    If start + numTiles + 1 > udTileSetIndex.Max Then start = udTileSetIndex.Max - numTiles + 1
    If start < 0 Then start = 0

    ' Draw current tiles
    For i = 0 To numTiles
        If wellFile(cmbTileSets.ListIndex).Paste(picTileSet.hDC, i * 33 + 1, 0, start + i) = 0 Then
            picTileSet.Line (i * 33 + 1, 0)-(i * 33 + 33, 32), RGB(239, 235, 222), BF
        End If
        If i + start = udTileSetIndex.Value Or i + start - 1 = udTileSetIndex.Value Then
            picTileSet.Line (i * 33, 0)-(i * 33, 32), RGB(255, 0, 0)
        Else
            picTileSet.Line (i * 33, 0)-(i * 33, 32), RGB(0, 0, 0)
        End If
    Next i
End Sub




Private Sub txtSpriteIndex_Change()
    ' Update the displayed sprite
    If Val(txtSpriteIndex.Text) <= udSpriteIndex.Max Then
        udSpriteIndex.Value = Val(txtSpriteIndex.Text)
    End If
    ' Update displayed value
    txtSpriteIndex.Text = Format$(udSpriteIndex.Value)
End Sub

Private Sub udSpriteIndex_Change()
    picSprite.Refresh
End Sub

Private Sub picSprite_Paint()
    Dim DataPtr As Long
    Dim bmInfo As BITMAPINFO

    ' Display some debug info
    picSprite.CurrentY = 0
    picSprite.CurrentX = 0
    picSprite.Print "Type: "; prtFile.ImageType(udSpriteIndex.Value)
    picSprite.Print "Palette: "; prtFile.ImagePalette(udSpriteIndex.Value)

    ' Paste the image to the picture box
    prtFile.Paste picSprite.hDC, (picSprite.ScaleWidth - prtFile.ImageWidth(udSpriteIndex.Value)) / 2, (picSprite.ScaleHeight - prtFile.ImageHeight(udSpriteIndex.Value)) / 2, udSpriteIndex.Value
End Sub

